// naumann@stce.rwth-aachen.de

#pragma once

/**
 * Algorithmic Differentiation
 */
template<typename T>
struct AD {
  T v=0,d=0;
  AD() {}
  AD(const T& v) : v(v) {}
  AD operator+=(const AD& w) {
    v+=w.v; d+=w.d;
    return *this;
  }
  AD operator-=(const AD& w) {
    v-=w.v; d-=w.d;
    return *this;
  }
  void diff_wrt(const char* v) { 
    std::cout << "running sensitivity analysis wrt. " << v << std::endl;
    d=1; 
  }
};

template<typename T>
T& value(AD<T>& x) {
  return x.v;
}

template<typename T>
T& derivative(AD<T>& x) {
  return x.d;
}

#include "AD.cpp"
