// naumann@stce.rwth-aachen.de

#include <fstream> 
#include <cmath> 
#include <vector> 
#include <limits>

  template<typename T>
  data<T>::data(char* fn) : filename(fn) {
    std::ifstream ifs(filename); 
    size_t m=0; ifs >> m; 
    T x,y; 
    for (size_t i=0;i<m;i++) {
      ifs >> x >> y; observations.push_back(std::make_pair(x,y));
    }
    ifs.close(); 
  }

  template<typename T>
  data<T>::~data() {
    std::ofstream ofs(filename); 
    ofs << observations.size() << std::endl; 
    for (const auto& o : observations) 
      ofs << o.first << " " << o.second << std::endl;
    ofs.close(); 
  }

  template<typename T>
  void data<T>::add_observation(const T& x, const T &y) {
    observations.push_back(std::make_pair(x,y));
  }

  template<typename T>
  const std::vector<std::pair<T,T>>& data<T>::get_observations() const {
    return observations;
  }

  template<typename T>
  void data<T>::plot() const {
    std::ofstream ofs("data.plot"); 
    for (const auto& o : observations) 
      ofs << o.first << " " << o.second << std::endl;
    ofs.close(); 
  }

