// naumann@stce.rwth-aachen.de

#include <iostream> 
#include <cassert> 

#include "data.hpp"
#include "linear_model.hpp"
#include "nonlinear_model.hpp"
#include "AD.hpp"

int main(int argc, char *argv[]) {
  assert(argc==3); 
  using T=AD<double>;
  data<T> d(argv[1]); nonlinear_model<T> m(d,argv[2]); 
  T x,y;
  std::cout << "new observation:" << std::endl;
  std::cout << "x="; std::cin >> x;
  std::cout << "y="; std::cin >> y;
  x.diff_wrt("x");
  d.add_observation(x,y);
  m.calibrate();
  std::cout << "sensitivity of p: " << derivative(m.parameter()) << std::endl;
  std::cout << "new simulation:" << std::endl;
  std::cout << "x="; std::cin >> x;
  y=m.evaluate(x);
  std::cout << "y=" << y << std::endl;
  std::cout << "sensitivity of y: " << derivative(y) << std::endl;
  d.plot(); m.plot();
  return 0;
}
